"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Signature = void 0;
// Signature represents the secp256k1 signature of a Guardian
class Signature {
    r;
    s;
    v;
    constructor(r, s, v) {
        this.r = r;
        this.s = s;
        this.v = v;
    }
    toUint8Array() {
        const buff = new Uint8Array(65);
        buff.set(Buffer.from(this.r.toString(16), "hex"));
        buff.set(Buffer.from(this.s.toString(16), "hex"), 32);
        buff.set([this.v], 64);
        return buff;
    }
    toBuffer() {
        return Buffer.from(this.toUint8Array());
    }
}
exports.Signature = Signature;
//# sourceMappingURL=signature.js.map