import { PlatformName } from "@wormhole-foundation/sdk-base";
import { ChainAddress, NativeAddress, RpcConnection, TokenBridge, UniversalOrNative, UnsignedTransaction, VAA } from "../..";
export declare class MockTokenBridge<P extends PlatformName> implements TokenBridge<P> {
    readonly rpc: RpcConnection<P>;
    constructor(rpc: RpcConnection<P>);
    isWrappedAsset(token: UniversalOrNative<P>): Promise<boolean>;
    getOriginalAsset(token: UniversalOrNative<P>): Promise<ChainAddress>;
    hasWrappedAsset(original: ChainAddress): Promise<boolean>;
    getWrappedAsset(original: ChainAddress): Promise<NativeAddress<P>>;
    isTransferCompleted(vaa: VAA<"Transfer"> | VAA<"TransferWithPayload">): Promise<boolean>;
    createAttestation(address: UniversalOrNative<P>): AsyncGenerator<UnsignedTransaction>;
    submitAttestation(vaa: VAA<"AttestMeta">): AsyncGenerator<UnsignedTransaction>;
    transfer(sender: UniversalOrNative<P>, recipient: ChainAddress, token: "native" | UniversalOrNative<P>, amount: bigint, payload?: Uint8Array | undefined): AsyncGenerator<UnsignedTransaction>;
    redeem(sender: UniversalOrNative<P>, vaa: VAA<"Transfer"> | VAA<"TransferWithPayload">, unwrapNative?: boolean | undefined): AsyncGenerator<UnsignedTransaction>;
    getWrappedNative(): Promise<NativeAddress<P>>;
}
//# sourceMappingURL=tokenBridge.d.ts.map