import { ChainName, ExplorerSettings, PlatformName } from "@wormhole-foundation/sdk-base";
import { ChainAddress } from "./address";
import { Contracts } from "./contracts";
import { UnsignedTransaction } from "./unsignedTransaction";
export type TxHash = string;
export type SequenceId = bigint;
export type SignedTx = any;
export type TokenId = ChainAddress;
export declare function isTokenId(thing: TokenId | any): thing is TokenId;
export interface Signer {
    chain(): ChainName;
    address(): string;
    sign(tx: UnsignedTransaction[]): Promise<SignedTx[]>;
}
export declare function isSigner(thing: Signer | any): thing is Signer;
export declare function nativeChainAddress(s: Signer | TokenId): TokenId;
export type TransactionId = {
    chain: ChainName;
    txid: TxHash;
};
export declare function isTransactionIdentifier(thing: TransactionId | any): thing is TransactionId;
export type ChainConfig = {
    key: ChainName;
    platform: PlatformName;
    contracts: Contracts;
    finalityThreshold: number;
    nativeTokenDecimals: number;
    explorer: ExplorerSettings;
    rpc: string;
};
export type ChainsConfig = {
    [K in ChainName]?: ChainConfig;
};
//# sourceMappingURL=types.d.ts.map