"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTransactionIdentifier = exports.nativeChainAddress = exports.isSigner = exports.isTokenId = void 0;
const sdk_base_1 = require("@wormhole-foundation/sdk-base");
const address_1 = require("./address");
function isTokenId(thing) {
    return (typeof thing.address !== undefined &&
        (0, sdk_base_1.isChain)(thing.chain));
}
exports.isTokenId = isTokenId;
function isSigner(thing) {
    return (typeof thing.chain === "function" &&
        typeof thing.address == "function" &&
        typeof thing.sign === "function");
}
exports.isSigner = isSigner;
function nativeChainAddress(s) {
    if (isSigner(s))
        return {
            chain: s.chain(),
            address: (0, address_1.toNative)(s.chain(), s.address()),
        };
    return {
        chain: s.chain,
        address: s.address.toNative(s.chain),
    };
}
exports.nativeChainAddress = nativeChainAddress;
function isTransactionIdentifier(thing) {
    return (thing.chain !== undefined &&
        thing.txid !== undefined);
}
exports.isTransactionIdentifier = isTransactionIdentifier;
//# sourceMappingURL=types.js.map