import { Chain, PlatformName } from "@wormhole-foundation/sdk-base";
import { UniversalOrNative } from "./address";
export interface Relayer<P extends PlatformName> {
    relaySupported(chain: Chain): boolean;
    getRelayerFee(sourceChain: Chain, destChain: Chain, tokenId: UniversalOrNative<P>): Promise<bigint>;
    startTransferWithRelay(token: UniversalOrNative<P> | "native", amount: bigint, toNativeToken: string, sendingChain: Chain, senderAddress: string, recipientChain: Chain, recipientAddress: string, overrides?: any): Promise<any>;
    calculateNativeTokenAmt(destChain: Chain, tokenId: UniversalOrNative<P>, amount: bigint, walletAddress: string): Promise<bigint>;
    calculateMaxSwapAmount(destChain: Chain, tokenId: UniversalOrNative<P>, walletAddress: string): Promise<bigint>;
}
//# sourceMappingURL=relayer.d.ts.map