import { isChain, } from "@wormhole-foundation/sdk-base";
import { toNative } from "./address";
export function isTokenId(thing) {
    return (typeof thing.address !== undefined &&
        isChain(thing.chain));
}
export function isSigner(thing) {
    return (typeof thing.chain === "function" &&
        typeof thing.address == "function" &&
        typeof thing.sign === "function");
}
export function nativeChainAddress(s) {
    if (isSigner(s))
        return {
            chain: s.chain(),
            address: toNative(s.chain(), s.address()),
        };
    return {
        chain: s.chain,
        address: s.address.toNative(s.chain),
    };
}
export function isTransactionIdentifier(thing) {
    return (thing.chain !== undefined &&
        thing.txid !== undefined);
}
//# sourceMappingURL=types.js.map