import { ShallowMapping } from "@wormhole-foundation/sdk-base";
export declare const connectPayloads: readonly [readonly ["CircleTransferRelay", readonly [{
    readonly name: "payloadId";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 1;
    readonly omit: true;
}, {
    readonly name: "token";
    readonly binary: "object";
    readonly layout: readonly [{
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "address";
    }, {
        readonly binary: "uint";
        readonly size: 32;
        readonly name: "amount";
    }];
}, {
    readonly name: "sourceDomain";
    readonly binary: "uint";
    readonly size: 4;
}, {
    readonly name: "targetDomain";
    readonly binary: "uint";
    readonly size: 4;
}, {
    readonly name: "nonce";
    readonly binary: "uint";
    readonly size: 8;
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "caller";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "mintRecipient";
}, {
    readonly name: "payloadSize";
    readonly binary: "uint";
    readonly size: 2;
}, {
    readonly name: "relayerPayload";
    readonly binary: "object";
    readonly layout: readonly [{
        readonly name: "payloadId";
        readonly binary: "uint";
        readonly size: 1;
        readonly custom: 1;
        readonly omit: true;
    }, {
        readonly binary: "uint";
        readonly size: 32;
        readonly name: "targetRelayerFee";
    }, {
        readonly binary: "uint";
        readonly size: 32;
        readonly name: "toNativeTokenAmount";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "targetRecipient";
    }];
}]]];
declare global {
    namespace Wormhole {
        interface PayloadLiteralToDescriptionMapping extends ShallowMapping<typeof connectPayloads> {
        }
    }
}
//# sourceMappingURL=connect.d.ts.map