"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.connectPayloads = void 0;
const layout_items_1 = require("../layout-items");
const vaa_1 = require("../vaa");
const circleTransferRelay = [
    (0, layout_items_1.payloadIdItem)(1),
    {
        name: "token",
        binary: "object",
        layout: [
            { name: "address", ...layout_items_1.universalAddressItem },
            { name: "amount", ...layout_items_1.amountItem },
        ],
    },
    { name: "sourceDomain", binary: "uint", size: 4 },
    { name: "targetDomain", binary: "uint", size: 4 },
    { name: "nonce", binary: "uint", size: 8 },
    { name: "caller", ...layout_items_1.universalAddressItem },
    { name: "mintRecipient", ...layout_items_1.universalAddressItem },
    { name: "payloadSize", binary: "uint", size: 2 },
    {
        name: "relayerPayload",
        binary: "object",
        layout: [
            (0, layout_items_1.payloadIdItem)(1),
            { name: "targetRelayerFee", ...layout_items_1.amountItem },
            { name: "toNativeTokenAmount", ...layout_items_1.amountItem },
            { name: "targetRecipient", ...layout_items_1.universalAddressItem },
        ],
    },
];
exports.connectPayloads = [
    ["CircleTransferRelay", circleTransferRelay],
];
exports.connectPayloads.forEach(([payloadLiteral, layout]) => (0, vaa_1.registerPayloadType)(payloadLiteral, layout));
//# sourceMappingURL=connect.js.map